
#ifdef _ASSEMBLER_
#define _PD
#else
#define _PD(x) (*(volatile unsigned char *) (x))
#endif

#define F 1
#define W 0
;// 0x000 - 0x07F

#define INDF    _PD(0x000)
#define TMR0    _PD(0x001)
#define PCL     _PD(0x002)
#define STATUS  _PD(0x003)
#define FSR     _PD(0x004)
#define PORTA   _PD(0x005)
#define PORTB   _PD(0x006)
#define EEDATA  _PD(0x008)
#define EEADR	_PD(0x009)
#define PCLATH	_PD(0x00A)
#define INTCON	_PD(0x00B)

;// 0x080 - 0x0FF

#define OPTION_REG _PD(0x081)
#define TRISA      _PD(0x085)
#define TRISB      _PD(0x086)
#define EECON1     _PD(0x088)
#define EECON2     _PD(0x089)

;// Bits 0x000 - 0x07F
;//STATUS
#define IRP 7
#define RP1 6
#define RP0 5
#define TO 4
#define PD 3
#define Z 2
#define DC 1
#define C 0

;//INTCON
#define GIE 7
#define EEIE 6
#define T0IE 5
#define INTE 4
#define RBIE 3
#define T0IF 2
#define INTF 1
#define RBIF 0

;//EECON1
#define EEIF 4
#define WRERR 3
#define WREN 2
#define WR 1
#define RD 0

;// Configuration word
;//FLASH PROTECT READ
#define CP_EN	0x000F
#define CP_DIS	0x3FFF

;//PWRTE
#define PWRTE_DIS 0x3FFF
#define PWRTE_EN  0x3FF7

;//WATCHDOG
#define WDT_DIS 0x3FFB
#define WDT_EN  0x3FFF

;//OSCILLATOR
#define RC_OSC 0x3EFF
#define HS_OSC 0x3EFE
#define XT_OSC 0x3EFD
#define LP_OSC 0x3EFC
