
#ifdef _ASSEMBLER_
#define _PD
#else
#define _PD(x) (*(volatile unsigned char *) (x))
#endif

#define F 1
#define W 0
;// 0x000 - 0x07F

#define INDF    _PD(0x000)
#define TMR0    _PD(0x001)
#define PCL     _PD(0x002)
#define STATUS  _PD(0x003)
#define FSR     _PD(0x004)
#define PORTA   _PD(0x005)
#define PORTB   _PD(0x006)
#define PORTC   _PD(0x007)
#define PORTD   _PD(0x008)
#define PORTE   _PD(0x009)
#define PCLATH  _PD(0x00A)
#define INTCON  _PD(0x00B)
#define PIR1    _PD(0x00C)
#define PIR2    _PD(0x00D)
#define TMR1L   _PD(0x00E)
#define TMR1H   _PD(0x00F)
#define T1CON   _PD(0x010)
#define TMR2    _PD(0x011)
#define T2CON   _PD(0x012)
#define SSPBUF  _PD(0x013)
#define SSPCON  _PD(0x014)
#define CCPR1L  _PD(0x015)
#define CCPR1H  _PD(0x016)
#define CCP1CON _PD(0x017)
#define RCSTA   _PD(0x018)
#define TXREG   _PD(0x019)
#define RCREG   _PD(0x01A)
#define CCPR2L  _PD(0x01B)
#define CCPR2H  _PD(0x01C)
#define CCP2CON _PD(0x01D)
#define ADRESH  _PD(0x01E)
#define ADCON0  _PD(0x01F)

;// 0x080 - 0x0FF

#define OPTION_REG _PD(0x081)
#define TRISA      _PD(0x085)
#define TRISB      _PD(0x086)
#define TRISC      _PD(0x087)
#define TRISD      _PD(0x088)
#define TRISE      _PD(0x089)
#define PIE1       _PD(0x08C)
#define PIE2       _PD(0x08D)
#define PCON       _PD(0x08E)
#define SSPCON2    _PD(0x091)
#define PR2        _PD(0x092)
#define SSPADD     _PD(0x093)
#define SSPSTAT    _PD(0x094)
#define TXSTA      _PD(0x098)
#define SPBRG      _PD(0x099)
#define ADRESL     _PD(0x09E)
#define ADCON1     _PD(0x09F)

;// 0x100 - 0x17F

#define EEDATA _PD(0x10C)
#define EEADR  _PD(0x10D)
#define EEDATH _PD(0x10E)
#define EEADRH _PD(0x10F)

;// 0x180 - 0x1FF

#define EECON1 _PD(0x18C)
#define EECON2 _PD(0x18D)


;// Bits 0x000 - 0x07F
;//STATUS
#define IRP 7
#define RP1 6
#define RP0 5
#define TO 4
#define PD 3
#define Z 2
#define DC 1
#define C 0

;//INTCON
#define GIE 7
#define PEIE 6
#define T0IE 5
#define INTE 4
#define RBIE 3
#define T0IF 2
#define INTF 1
#define RBIF 0

;//PIR1
#define PSPIF 7
#define ADIF 6
#define RCIF 5
#define TXIF 4
#define SSPIF 3
#define CCP1IF 2
#define TMR2IF 1
#define TMR1IF 0

;//PIR2
#define EEIF 4
#define BCLIF 3
#define CCP2IF 0

;//T1CON
#define T1CKPS1 5
#define T1CKPS0 4
#define T1OSCEN 3
#define T1SYNC 2
#define TMR1CS 1
#define TMR1ON 0

;//T2CON
#define TOUTPS3 6
#define TOUTPS2 5
#define TOUTPS1 4
#define TOUTPS0 3
#define TMR2ON 2
#define T2CKPS1 1
#define T2CKPS0 0

;//SSPCON
#define WCOL 7
#define SSPOV 6
#define SSPEN 5
#define CKP 4
#define SSPM3 3
#define SSPM2 2
#define SSPM1 1
#define SSPM0 0

;//CCP1CON
#define CCP1X 5
#define CCP1Y 4
#define CCP1M3 3
#define CCP1M2 2
#define CCP1M1 1
#define CCP1M0 0

;//RCSTA
#define SPEN 7
#define RX9 6
#define SREN 5
#define CREN 4
#define ADDEN 3
#define FERR 2
#define OERR 1
#define RX9D 0

;//CCP2CON
#define CCP2X 5
#define CCP2Y 4
#define CCP2M3 3
#define CCP2M2 2
#define CCP2M1 1
#define CCP2M0 0

;//ADCON0
#define ADCS1 7
#define ADCS0 6
#define CHS2 5
#define CHS1 4
#define CHS0 3
#define GO 2
#define DONE 2
#define ADON 0

;// Bits 0x080 - 0x0FF

;//OPTION_REG
#define RBPU 7
#define INTEDG 6
#define T0CS 5
#define T0SE 4
#define PSA 3
#define PS2 2
#define PS1 1
#define PS0 0

;//TRISE
#define IBF 7
#define OBF 6
#define IBOV 5
#define PSPMODE 4

;//PCON
#define POR 1
#define BOR 0

;//SSPCON2
#define GCEN 7
#define ACKSTAT 6
#define ACKDT 5
#define ACKEN 4
#define RCEN 3
#define PEN 2
#define RSEN 1
#define SEN 0

;//SSPSTAT
#define SMP 7
#define CKE 6
#define DA 5
#define P 4
#define S 3
#define RW 2
#define UA 1
#define BF 0

;//TXSTA
#define CSRC 7
#define TX9 6
#define TXEN 5
#define SYNC 4
#define BRGH 2
#define TRMT 1
#define TX9D 0

;//ADCON1
#define ADFM 7
#define PCFG3 3
#define PCFG2 2
#define PCFG1 1
#define PCFG0 0

;// Bits 0x180 - 0x1FF

;//EECON1
#define EEPGD 7
#define WRERR 3
#define WREN 2
#define WR 1
#define RD 0

;// Configuration word
;//FLASH PROTECT READ
#define CP_ALL		0x0FCF
#define CP_HALF		0x1FDF
#define CP_UPPER	0x2FEF
#define CP_OFF		0x3FFF

;//DEBUG
#define DEBUG_DIS 0x3FFF
#define DEBUG_EN  0x37FF

;//FLASH PROTECT WRITE
#define WRT_DIS 0x3DFF
#define WRT_EN  0x3FFF

;//EEPROM PROTECT
#define CPD_DIS 0x3EFF
#define CPD_EN  0x3FFF

;//LOW VOLTAJE PROGRAMMING
#define LVP_DIS 0x3F7F
#define LVP_EN  0x3FFF

;//BOR
#define BOR_DIS 0x3FBF
#define BOR_EN  0x3FFF

;//PWRTE
#define PWRTE_DIS 0x3FFF
#define PWRTE_EN  0x3FF7

;//WATCHDOG
#define WDT_DIS 0x3FFB
#define WDT_EN  0x3FFF

;//OSCILLATOR
#define RC_OSC 0x3EFF
#define HS_OSC 0x3EFE
#define XT_OSC 0x3EFD
#define LP_OSC 0x3EFC
